/**
 *  Name: SrbJavaGlue.java
 *  Institution: National Center for Ecological Analysis and Synthesis
 *  Copyright: 2000 The Regents of the University of California and
 *         National Center for Ecological Analysis and Synthesis,
 *         University of California, Santa Barbara 2000.
 *         All rights reserved.
 *
 *  Authors: Dan Higgins, John Moreland
 *
 *     Version: '$Id: SrbJavaGlue.java,v 1.2 2000/11/13 18:08:57 bojilova Exp $'
 */
/**************************************************************************
Copyright ^ General Atomics, 1995-1999
All Rights Reserved
 
This file contains Original Code and/or Modifications of Original Code as
defined in and that are subject to the General Atomics Storage Resource
Broker Academic and Research Use  License (the 'License'). This license is
for academic and research use only. You may not use, copy, modify or
distribute SRB for commercial purposes, nor incorporate the SRB into
commercial products without the express written permission of General
Atomics nor may you distribute SRB to any third party.
 
You may not use this software except in compliance with the License. Please
obtain a copy of the License at http://www.npaci.edu/DICE/SRB/License and
read it before using this file.
 
The Original Code and all software distributed under the License are
distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
EXPRESS OR IMPLIED, AND GENERAL ATOMICS AND THE SAN DIEGO SUPERCOMPUTER
CENTER HEREBY DISCLAIM ALL SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION,
ANY WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR
NON-INFRINGEMENT OF ANY COPYRIGHT, PATENT , TRADEMARK OR OTHER RIGHTS.
GENERAL ATOMICS AND THE SAN DIEGO SUPERCOMPUTER CENTER FURTHER  HAVE NO
OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCMENTS OR
MODIFICATIONS.. Please see the License for the specific language governing
rights and limitations under the License."
 
Please read the terms of this license carefully. By using the SRB software,
you are accepting and agreeing to the terms of this license with General
Atomics. If you are agreeing to this license on behalf of a company, or
other institution, you represent that you are authorized to bind the
company/institution to such a license. If you do not meet this criterion or
you do not agree to any of the terms of this license, you are not
authorized to use the software.
**************************************************************************/

 /* Note: Based on Java code originally produced at SDSC
 * Copyright   1999   The Regents of the University of California
 * All Rights Reserved
 */

/**
 * SrbJavaGlue
 *
 * Implementation of RMI Interface
 *
 * @version 1.1 6/8/00
 * @author Dan Higgins - NCEAS
 * @version 1.0 10/23/97
 * @author John Moreland
 */
 
 import java.rmi.*;
 import java.rmi.server.*;
 import java.io.*;   //DFH 6/8/00
 
 
public class SrbJavaGlue extends UnicastRemoteObject implements SrbJavaGlueInterface

{
 byte[] ByteData;
 String FileName;
    
	// JNI (Java Native Interface) Glue Routines for the SRB client library.

public SrbJavaGlue() throws RemoteException {
                  super();
              }

	public native int clConnectJ( String host, String port, String auth,
	 String user, String domain );

	public native int srbListCollectJ( int conn, int catType,
		String collectionName, String flag, int types[] );

	public native String getFileListItem( int index );

	public native int clFinishJ( int conn );

	public native int srbObjCopyNewJ( String srcDir, String srcFile,
		String dstDir, String dstFile, String dstRes );

	public native int srbListResourceJ( int bs );

	public native String getResListItem( int index );

	public native String getDefCollection();

	public native String getDefResource();

	public native String getUser();

	public native String getDomain();

	public native String getLocalCacheDir();

	public native int srbObjReplicateJ(int conn, int catType,
	  String objID, String replNum, String collection, String resource);

	public native int srbCollReplicateJ(int conn, int catType,
	  String collection, String resource);

	public native int queryDataInCollJ (int conn, int catType, 
	  String parColl);

	public native int queryDataJ (int conn, int catType, String objID,
	  String parColl);

	public native int querySubCollInCollJ (int conn, int catType, 
	  String parColl);

	public native String getDataResultJ( int metaIndex, int rowIndex );

	public native String getCollResultJ( int metaIndex, int rowIndex );

	public native String getGenQueResultJ( int metaIndex, int rowIndex );

	public native int getNCollAttriJ ();

	public native int getNDataAttriJ ();

	public native int srbObjUnlinkJ (int conn,  int catType, 
	  String objID, String replNum, String parColl);

	public native int srbCreateCollectJ (int conn,  int catType, 
	  String parColl, String newColl);

	public native int srbModifyDatasetMetaDJ (int conn,  int catType,
	  String objID, String collection, 
	   String newValue1, String newValue2, int retractionType);
	public native int srbModifyCollectMetaDJ (int conn,  int catType,
	  String collection, String newValue1, String newValue2, 
	   String newValue3, int retractionType);
	public native int importToOldObjJ (int conn,  int catType, 
	  String objID, String replNum, String parColl, String resource,
	   String localFile, String container);

	public native int importToNewObjJ (int conn,  int catType, 
	 String objID, String parColl, String resource, String localFile,
	  String container);

	public native int importDirJ (int conn,  int catType, 
	  String parColl, String resource, String localDir, String container);

	public native int srbRmCollJ (int conn, int catType, String parColl);

	public native int srbUnregCollJ (int conn, int catType, String parColl);

	public native int copyToOldObjJ (int conn,  int catType, 
	 String objID, String replNum, String srcColl, String targObj, 
	  String targReplNum, String targColl, String targResource, 
	   String container);

	public native int copyDataToCollJ (int conn,  int catType, 
	 String objID, String replNum, String srcColl,
	  String dataType, String size, String targColl, String targResource,
	   String container);

	public native int copyCollToCollJ (int conn, int catType, 
	 String srcColl, String targColl, String targResource, 
	  String container);

	public native int exportToFileJ(int conn, int catType,
	 String objID, String replNum, String srcColl,
	  String targFile, int forceFlag);

	public native int exportToDirJ(int conn, int catType,
	 String objID, String replNum, String srcColl,
	  String targDir);

	public native int exportCollToDirJ(int conn, int catType,
	 String srcColl, String targDir);

	public native int srbGenQuery (int conn, int catType,
	 String[] qval, int qvalInx[], int selVal[]);
	
        public native int srbRegisterDatasetJ(int conn, int catType,
         String objID, String dataType, String resource, String collection,
	  String pathName, int dataSize);

	public native int srbUnregisterDatasetJ (int conn, int catType,
	 String objID, String replNum, String collection);

        public native int srbRegisterDirJ (int conn, int catType,
	 String srcDirPath, String targColl, String resource);

        public native int getMoreDataRowsJ (int conn, int catType);

        public native int getMoreCollRowsJ (int conn, int catType);

        public native int getMoreGenQueRowsJ (int conn, int catType);
	
	public native int chmodInCollJ (int conn, int catType, 
	 String collection, String user, String domain, String mode);

	public native int ingestUserJ (int conn, int catType, 
	 String userName, String passwd, String domain, 
	  String userType, String userAddr, String userPhone, String userEmail,
	   String parentColl);

	public native int ingestGroupJ (int conn, int catType, 
	 String groupName, String passwd,
	  String groupAddr, String groupPhone, String groupEMail);

	public native int ingestLocJ (int conn, int catType, 
	 String locName, String fullAddr, String parentLoc,
	  String serverUser, String serverUserDomain); 

        public native int ingestResourceJ (int conn, int catType,
         String rescName, String rescType, String location, String phyPath,
	  String rscClass, int size);

        public native int ingestLogRescJ (int conn, int catType,
         String logRescName, String phyResc, String phyPath);

        public native int addLogRescJ (int conn, int catType,
         String logResc, String phyResc, String phyPath);

        public native int modifyUserJ (int conn, int catType,
         int modOpr, String userName, String domain, String modValue);

	public native int containerCreateJ (int conn, int catType,
	 String contName, String dataType, String logResc, int size);

	public native int containerDeleteJ (int conn, int catType,
	 String contName, int forceFlag);

        public native int containerSyncJ (int conn, int catType,
         String contName, int purgeFlag);
         
 //DFH 6/8/00
 public byte[] getByteData(String name) {
    File tmp = new File("./tmp/");
    if (!tmp.exists()) { tmp.mkdir();}
  
    File temp = new File("./tmp/"+name);    // looks for file in tmp dir under current directory
    if (temp.exists()) {
        ByteData = new byte[(int)temp.length()];
        try{
            FileInputStream fis = new FileInputStream(temp);
            fis.read(ByteData);
            fis.close();
        }
        catch (Exception e) {;}
        temp.delete();
    }
    else {
        ByteData = new byte[0];   
    }
    return ByteData;
 } 
 
 public void setByteData(String name, byte[] in) {
    ByteData = in;
    FileName = name;
    File tmp = new File("./tmp/");
    if (!tmp.exists()) { tmp.mkdir();}

    File temp = new File("./tmp/"+name);
        try{
            FileOutputStream fos = new FileOutputStream(temp);
            fos.write(ByteData);
            fos.close();
        }
        catch (Exception e) {;}
 }
 
 public void clearTmpFiles() {
    File temp = new File("./tmp/"+FileName);
    if (temp.exists()) { temp.delete(); }
 }
 
 // --

	static
	{
		System.loadLibrary( "SrbJavaGlue" );

	}
	
	    public static void main(String[] args) {
                  if (System.getSecurityManager() == null) {
                      System.setSecurityManager(new RMISecurityManager());
                  }
                  String name = "//localhost/SrbJavaGlue";
                  if (args.length==1) name = "//localhost" + ":"+args[0]+"/SrbJavaGlue";
                  try {
                      SrbJavaGlue engine = new SrbJavaGlue();
                      Naming.rebind(name, engine);
                      System.out.println("SrbJavaGlue bound");
                  } catch (Exception e) {
                      System.err.println("SrbJavaGlue exception: " + 
                                         e.getMessage());
                      e.printStackTrace();
                  }
              }
	
	
}

